.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib
include comctl32.inc
includelib comctl32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
DrawIt proto hwnd:HANDLE
UseFont proto hFnt:HANDLE,idmi:DWORD

;**********************************************************************************************************

IDI_ICON        equ 100
IDP_MENU        equ 200
 IDM_FNTGUI      equ 211
 IDM_FNTSYS      equ 212
 IDM_FNTOEM      equ 213
 IDM_FNTSEL      equ 214

SQR_SIZE        equ 25
TAB_MARGIN      equ 5
TAB_WIDTH       equ 16*SQR_SIZE

IDSTATUS        equ 2001

;**********************************************************************************************************

.data
AppName     db "Charta",0
selstr      db "%u  (%02Xh)",0
margin      DWORD       TAB_MARGIN      ;to be moved to data?
sqrsize     DWORD       SQR_SIZE        ;to be moved to data?

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hMenu       HMENU       ?
hStatus     HWND        ?
hFont       HANDLE      ?
xSel        DWORD       ?
ySel        DWORD       ?
selBuff     db 32 dup (?)

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov eax,hInstance
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_BTNFACE+1
    invoke LoadMenu, hInstance,IDP_MENU
    mov hMenu,eax
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET AppName
    invoke LoadIcon, hInstance,IDI_ICON
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR AppName,ADDR AppName,WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU,CW_USEDEFAULT,CW_USEDEFAULT,420,480,NULL,hMenu,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        .WHILE TRUE
            invoke GetMessage, ADDR msg,NULL,0,0
            .BREAK .IF(!eax)
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage, ADDR msg
        .ENDW
        mov eax,msg.wParam
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_PAINT ----------------------------------------------------------------------------------------
    .IF (eax==WM_PAINT)
        invoke DrawIt, hwnd
;-- WM_LBUTTONDOWN ----------------------------------------------------------------------------------
    .ELSEIF (eax==WM_LBUTTONDOWN)
        mov eax,lParam
        mov ecx,eax
        and eax,0ffffh  ;xPos
        shr ecx,16      ;yPos
        sub eax,TAB_MARGIN
        sub ecx,TAB_MARGIN
        xor edx,edx
        div sqrsize
        cmp eax,0fh
        ja @inval
        mov xSel,eax
        xor edx,edx
        xchg eax,ecx
        div sqrsize
        mov ySel,eax
        cmp eax,0fh
        ja @inval
        shl eax,4
        add eax,ecx
        invoke wsprintf, ADDR selBuff,ADDR selstr,eax,eax
        invoke SendMessage, hStatus,SB_SETTEXT,0,ADDR selBuff
        jmp @okie
      @inval:
        mov eax,-1
        mov xSel,eax
        mov ySel,eax
        invoke SendMessage, hStatus,SB_SETTEXT,0,NULL
      @okie:
        invoke InvalidateRect, hwnd,NULL,TRUE
;-- WM_COMMAND --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_COMMAND)
        ;lParam is hWndCtl
        mov eax,wParam
        mov edx,eax
        and eax,0ffffh      ;item/control/accel ID
        shr edx,16          ;notification code (0=menu; 1=accelerator)
        .IF (eax==IDM_FNTGUI)
            invoke GetStockObject, DEFAULT_GUI_FONT
            invoke UseFont, eax,IDM_FNTGUI
        .ELSEIF (eax==IDM_FNTSYS)
            invoke GetStockObject, SYSTEM_FIXED_FONT
            invoke UseFont, eax,IDM_FNTSYS
        .ELSEIF (eax==IDM_FNTOEM)
            invoke GetStockObject, OEM_FIXED_FONT
            invoke UseFont, eax,IDM_FNTOEM
        .ELSEIF (eax==IDM_FNTSEL)
            ;ChooseFontDlg
            ;invoke UseFont, eax,IDM_FNTSEL
        .ENDIF
;-- WM_SIZE -----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SIZE)
        invoke SendMessage, hStatus,WM_SIZE,wParam,lParam
        ;resize window according to size required:
        ; width = 16*sqrsize + margin
        ; height = width + hStatus.height
        ;(will have to use AdjustWindowRect to get correct size with titlebar+menu)
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke InitCommonControls
        invoke CreateStatusWindow, WS_CHILD or WS_VISIBLE,NULL,hwnd,IDSTATUS
        mov hStatus,eax
        ;resize window so the grid fits snuggly - depending on the SQR_SIZE and TAB_MARGIN
        invoke GetStockObject, DEFAULT_GUI_FONT
        mov hFont,eax
        invoke CheckMenuRadioItem, hMenu,IDM_FNTGUI,IDM_FNTSEL,IDM_FNTGUI,MF_BYCOMMAND
        mov eax,-1
        mov xSel,eax
        mov ySel,eax
;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

DrawIt proc hwnd:HANDLE
    LOCAL ps:PAINTSTRUCT
    LOCAL cchar:DWORD
    LOCAL r:RECT
    push ebx
    push esi
    push edi
    invoke BeginPaint, hwnd,ADDR ps
    mov ebx,eax

    ;draw selection (if any)
    mov eax,xSel
    mov edx,ySel
    cmp eax,0fh
    ja @nosel
    cmp edx,0fh
    ja @nosel
    mov ecx,sqrsize
    push edx
    mul ecx
    add eax,margin
    mov [r.left],eax
    add eax,ecx
    mov [r.right],eax
    pop eax
    mul ecx
    add eax,margin
    mov [r.top],eax
    add eax,ecx
    mov [r.bottom],eax
    invoke FillRect, ebx,ADDR r,COLOR_BTNSHADOW+1
  @nosel:

    ;draw grid
    mov esi,TAB_MARGIN
  @@:
    invoke MoveToEx, ebx,TAB_MARGIN,esi,NULL
    invoke LineTo, ebx,TAB_WIDTH+TAB_MARGIN+1,esi
    invoke MoveToEx, ebx,esi,TAB_MARGIN,NULL
    invoke LineTo, ebx,esi,TAB_WIDTH+TAB_MARGIN+1
    add esi,SQR_SIZE
    cmp esi,TAB_WIDTH+TAB_MARGIN
    jle @B

    ;draw chars
    mov eax,hFont
    invoke SelectObject, ebx,eax
    invoke SetBkMode, ebx,TRANSPARENT
    xor eax,eax
    mov cchar,eax
    mov esi,TAB_MARGIN+(SQR_SIZE/3)       ;--don't do /3 - get font metrics and centre it properely; also adjust sqr_size(?)
    mov edi,TAB_MARGIN+(SQR_SIZE/3)
  @@:
    invoke TextOut, ebx,esi,edi,ADDR cchar,1
    add esi,SQR_SIZE
    mov eax,cchar
    add eax,1
    mov cchar,eax
    test eax,0fh
    jnz @B
    mov esi,TAB_MARGIN+(SQR_SIZE/3)
    add edi,SQR_SIZE
    cmp eax,100h
    jl @B
    
    invoke EndPaint, hwnd,ADDR ps
    pop edi
    pop esi
    pop ebx
    ret
DrawIt endp

UseFont proc hFnt:HANDLE,idmi:DWORD
    invoke DeleteObject, hFont
    mov eax,hFnt
    mov hFont,eax

    ;get metrics and stuff

    invoke CheckMenuRadioItem, hMenu,IDM_FNTGUI,IDM_FNTSEL,idmi,MF_BYCOMMAND
    invoke InvalidateRect, hWnd,NULL,TRUE
    ret
UseFont endp

end start
